#include <iostream>
#include <cstdio>
#include <algorithm>
#include <map>
#include <cstring>

using namespace std;

/**
    Ardelean Răzvan
    Soluție cautcuv - 100p

    Una dintre soluțiile de 100 de puncte folosește o mapă.
*/

map<string, int> mapacs;
map<string, int> mapancs;

int n, nCuv, nText;
char text[200010];
char cuvinte[50010][52];

/*void strupr(char *s)
{
    int ns = strlen(s);
    for(int i = 0; i < ns; i++)
        if('a' <= s[i] && s[i] <= 'z')
            s[i] += 'A' - 'a';
}*/

void descompunere()
{
    char *p = strtok(text, " .,:;?!");
    while(p)
    {
        strcpy(cuvinte[nCuv++], p);
        p = strtok(NULL, " .,:;?!");
    }
}

void rezolvare()
{
    for(int i = 0; i < nCuv; i++)
    {
        mapacs[string(cuvinte[i])] = 1;
        strupr(cuvinte[i]);
        mapancs[string(cuvinte[i])] = 1;
    }
    char cuv[52];
    int cs;
    for(int i = 0; i < n; i++)
    {
        scanf("%s %d\n", cuv, &cs);
        if(cs)
            if(mapacs.find(string(cuv)) != mapacs.end())
                printf("1\n");
            else
                printf("0\n");
        else
        {
            strupr(cuv);
            if(mapancs.find(string(cuv)) != mapancs.end())
                printf("1\n");
            else
                printf("0\n");
        }
    }
}

int main()
{
    freopen("cautcuv.in", "r", stdin);
    freopen("cautcuv.out", "w", stdout);

    gets(text);
    descompunere();
    scanf("%d\n", &n);

    rezolvare();

    return 0;
}
