#include <bits/stdc++.h>

using namespace std;
const int Nmax = 50000 + 1;

int N, M, Q;
vector<int> G[Nmax];
map<pair<set<int>, bool>, bool> D2;
map<pair<vector<int>, bool>, bool> D;
int steps;

int generalGrundyDP(vector<int> s, int player) {
    ++ steps;
    if(steps % 5000 == 0)
        cerr << steps;
    pair<vector<int>, bool> crt = make_pair(s, player);
    if(D.find(crt) != D.end())
        return D[crt];

    bool isDone = true;
    for(vector<int>::iterator it = s.begin(); it != s.end(); ++it)
        if(G[*it].size() != 0) {
            isDone = false;
            break;
        }

    if(isDone) {
        D[crt] = false;
        return D[crt];
    }

    D[crt] = 0;

    vector<int> sPrime;
    for(vector<int>::iterator it = s.begin(); it != s.end(); ++it)
        sPrime.push_back(*it);

    for(vector<int>::iterator it = s.begin(); it != s.end(); ++it) {
        for(vector<int>::iterator jt = G[*it].begin(); jt != G[*it].end(); ++jt) {
            sPrime.erase(find(sPrime.begin(), sPrime.end(), *it));
            if(find(sPrime.begin(), sPrime.end(), *jt) == sPrime.end()) {
                sPrime.push_back(*jt);
                sort(sPrime.begin(), sPrime.end());
                if(generalGrundyDP(sPrime, player ^ 1) == 0) {
                    D[crt] = true;
                    return D[crt];
                }
                sPrime.erase(find(sPrime.begin(), sPrime.end(), *jt));
            }
            sPrime.push_back(*it);
            sort(sPrime.begin(), sPrime.end());
        }
    }
    return D[crt];
}
/**
int grundyDP(int nodi, int nodj, int p)
{
    if(DP[nodi][nodj][p] != -1)
        return DP[nodi][nodj][p];

    if(G[nodi].size() == 0 && G[nodj].size() == 0) {
        DP[nodi][nodj][p] = 0;
        DP[nodj][nodi][p] = 0;
        return DP[nodi][nodj][p];
    }

    for(vector<int>::iterator it = G[nodi].begin(); it != G[nodi].end(); ++it)
        if(*it != nodj && grundyDP(*it, nodj, p ^ 1) == 0) {
            DP[nodi][nodj][p] = 1;
            DP[nodj][nodi][p] = 1;
            return DP[nodj][nodi][p];
        }
    for(vector<int>::iterator it = G[nodj].begin(); it != G[nodj].end(); ++it)
        if(*it != nodi && grundyDP(nodi, *it, p ^ 1) == 0) {
            DP[nodi][nodj][p] = 1;
            DP[nodj][nodi][p] = 1;
            return DP[nodj][nodi][p];
        }

    DP[nodi][nodj][p] = 0;
    DP[nodj][nodi][p] = 0;

    return DP[nodi][nodj][p];
}
*/

int main()
{
    freopen("gaming.in", "r", stdin);
    freopen("gaming.ok", "w", stdout);

    scanf("%d%d%d", &N, &M, &Q);

    for(int i = 1; i <= M; ++i) {
        int a, b;
        scanf("%d%d",&a, &b);
        G[a].push_back(b);
    }



    for(int i = 1; i <= Q; ++i) {
        int cate, a, c;
        scanf("%d", &cate);
        vector<int> s;
        for(int j = 1; j <= cate; ++j) {
            scanf("%d", &a);
            s.push_back(a);
        }
        scanf("%d", &c);
        sort(s.begin(), s.end());
        if(generalGrundyDP(s, c))
            printf("%d\n", c);
        else
            printf("%d\n", 1 - c);
    }

    return 0;
}
